unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, MMSystem, ExtCtrls, StdCtrls;

type
  TPointArr = array [0..127] of TPoint;
  PPointArr = ^TPointArr;

  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    procedure StopRecord;
  end;

var
  Form1: TForm1;
  WaveIn: hWaveIn;
  hBuf: THandle;
  BufHead: TWaveHdr;
  bufsize: integer;
  p: PPointArr;  //  
  stop: boolean = false;
  XScale, YScale: single;

  po:array [0..10] of wavehdr_tag;
  data:array [0..10] of array of byte; //   
  Channels,Resolution:word;
  header:tWaveFormatEx;
  BytesPerSecond, SampleRate, DataBytes: LongInt;
  z1:integer; //
  siz:cardinal;
  j:integer; //   

implementation

{$R *.dfm}

function RRound(x:extended):integer; // 
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

procedure waveInProc(hwo:HWAVEIN; uMsg:UINT; dwInstance:DWORD; dwParam1:DWORD;dwParam2:DWORD);stdcall;
 var i:integer;
begin
 if uMsg=WIM_DATA then begin
   YScale:=form1.PaintBox1.Height/256;;
   XScale:=form1.PaintBox1.Width/BufSize;

   copymemory(@data[j][0],PWaveHdr(dwParam1)^.lpData,BufSize);  //  !!!   data[j][ 0  BufSize-1 ] 8   
   for i:=0 to BufSize-1 do begin
 //   if abs(127-data[j][i])>100 then data[j][i]:=0;
    p^[i]:=Point(RRound(i*XScale),RRound((256-data[j][i])*YScale));
   end;

   if form1.CheckBox1.Checked then begin  //  
    waveOutWrite(z1,@po[j],siz);
    inc(j);
    if j>high(po) then j:=0;
   end;

   with form1.PaintBox1.canvas do begin  // 
    Brush.Color:=0;
    FillRect(ClipRect);
    Polyline(Slice(p^, BufSize));
   end;

   if stop then
    WaveInAddBuffer(WaveIn, PWaveHdr(dwParam1), SizeOf(TWaveHdr))
   else stop:=true;
 end;
end;

procedure TForm1.StopRecord;
begin
 waveOutReset(z1);
 if stop=false then Exit;
 stop:=false;
 while not stop do Application.ProcessMessages;
 stop:=false;
 WaveInReset(WaveIn);
 WaveInUnPrepareHeader(WaveIn, addr(BufHead), sizeof(BufHead));
 WaveInClose(WaveIn);
 GlobalUnlock(hBuf);
 GlobalFree(hBuf);
 FreeMem(p, BufSize*sizeof(TPoint));
end;

procedure TForm1.Button1Click(Sender: TObject);
 var BufLen: word;
     buf: pointer;
begin
 if Button1.Caption='Start' then begin
  Button1.Caption:='Stop';
  j:=0;

  WaveInOpen(Addr(WaveIn), WAVE_MAPPER, @header,
             cardinal(@waveInProc), 0, CALLBACK_FUNCTION);

  BufLen:=header.nBlockAlign*BufSize;
  hBuf:=GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, BufLen);
  Buf:=GlobalLock(hBuf);
  with BufHead do begin
   lpData:=Buf;
   dwBufferLength:=BufLen;
   dwFlags:=WHDR_BEGINLOOP;
  end;
  WaveInPrepareHeader(WaveIn, Addr(BufHead), sizeof(BufHead));
  WaveInAddBuffer(WaveIn, addr(BufHead), sizeof(BufHead));
  GetMem(p, BufSize*sizeof(TPoint));
  stop:=true;
  WaveInStart(WaveIn);
 end else begin
  Button1.Caption:='Start';
  StopRecord;
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
 var i:integer;
begin
 StopRecord;
 waveOutReset(z1);
 for i:=0 to high(po) do
  waveOutUnprepareHeader(z1,@po[i],sizeof(po[0]));
 waveOutClose(z1);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if stop then begin
  StopRecord;
  Button1.Click;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var i:integer;
begin
 BufSize:=2000; {   } //   
 Channels:=1;
 SampleRate:=44100;
 Resolution:=8;
 PaintBox1.canvas.pen.color:=65280;

 BytesPerSecond:=Channels*SampleRate*Resolution div 8;
 DataBytes:=BufSize*(Resolution div 8)*Channels;

 header.wFormatTag:=WAVE_FORMAT_PCM;
 header.nChannels:=Channels;
 header.nSamplesPerSec:=SampleRate;
 header.wBitsPerSample:=Resolution;
 header.nAvgBytesPerSec:=BytesPerSecond;
 header.nBlockAlign:=channels*(Resolution div 8);
 header.cbSize:=0;

 waveOutOpen(@z1,0,@header,0,0,CALLBACK_NULL);
 siz:=sizeof(po[0]);

 for i:=0 to high(po) do begin
  setlength(data[i],BufSize);
  fillmemory(@po[i],sizeof(po[0]),0);
  po[i].lpData:=@data[i][0];
  po[i].dwBufferLength:=DataBytes;
  waveOutPrepareHeader(z1,@po[i],siz);
 end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 with PaintBox1.canvas do begin
  Brush.Color:=0;
  FillRect(ClipRect);
 end;
end;

end.
